# 通用网页视频下载油猴脚本

## 特性
- 使用JS-Hook技术基于MediaSource原理捕获解密后的原始视频流,通杀几乎所有网页视频防下载保护方案
- 下载后的文件为原始数据,无视视频中的水印
- 支持直播流

## 已测试场景
- bilibili所有视频含付费保护视频
- bilibili直播
- 虎牙直播
- 慕课网
- 腾讯课堂
- 极客时间
- P站 -_-;

## 用法
- 使用油猴插件导入脚本,修改作用域
- 脚本生效后视频完成加载会自动完成下载
- 下载后的文件需要使用FFmpeg完成音视频合并

## 参数
```javascript
//快进抓取
jsMedia.setSpeed(10);
//完成后自动下载
jsMedia.enableAutoDownload = true;
//手工触发下载
jsMedia.download();
```

## FFmpeg合并示例
```shell
ffmpeg -i audio.mp4 -acodec copy audio.aac
ffmpeg -i audio.aac -i video.mp4 -c copy -bsf:a aac_adtstoasc out.mp4
```

## 大文件分段需要先文件合并
```
copy /b media_0_*.mp4 out.mp4
```

## 特别说明
- 仅限内部交流使用,请勿用于非法用途